﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

//////////////////////////////////////////////////////////////////
//【Cameraのコントロールに使用するクラス】
// CameraをPlayerの位置に合わせて移動させる
//////////////////////////////////////////////////////////////////
public class CameraController : MonoBehaviour
{
    /////////////////////////////////
    // 【変数の設定】
    /////////////////////////////////

    //【定数の設定】（レベル設計で変更可能）
    const float SCREEN_TOP = 7;  // スクリーンの上限
    const float SCREEN_BOTTOM = -5;  // スクリーンの下限
    const float SCREEN_LEFT = -4;  // スクリーンの左端
    const float SCREEN_RIGHT = 4;  // スクリーンの右端

    //【Unity Editorから設定するPublic変数】
    public GameObject player;  // Scene上のPlayerゲームオブジェクト


    /////////////////////////////////
    // 【関数の設定】
    /////////////////////////////////

    //【毎フレームに１度動く関数】
    //（Unityの標準関数）
    void Update()
    {
        // Playerの位置を取得
        Vector3 playerPos = player.transform.position;

        // Playerの縦の位置がスクリーンの下限から上限の間にある場合
        if (playerPos.y > SCREEN_BOTTOM && playerPos.y < SCREEN_TOP)
        { 
            // カメラの縦の位置をPlayerの位置に合わせて移動させる
            transform.position = 
                new Vector3(transform.position.x, playerPos.y, 
                        transform.position.z);
        }

        // Playerの横の位置がスクリーンの左端から右端の間にある場合
        if (playerPos.x > SCREEN_LEFT && playerPos.x < SCREEN_RIGHT)
        {
            // カメラの横の位置をPlayerの位置に合わせて移動させる
            transform.position = 
                new Vector3(playerPos.x, transform.position.y, 
                        transform.position.z);
        }
    }
}
