﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

using UnityEngine.SceneManagement;  // シーンの切り替えに使用
using UnityEngine.UI;  // UIを使用するのに使用

//////////////////////////////////////////////////////////////////
//【ゲーム全体の管理に使用するクラス】
// ゲームの経過時間を計測・表示、ゲームオーバー処理・リスタート処理を実行
//////////////////////////////////////////////////////////////////
public class GameManager : MonoBehaviour
{
    /////////////////////////////////
    // 【変数の設定】
    /////////////////////////////////

    //【Unity Editorから設定するPublic変数】
    public GameObject text_GameOver;  // UIにGame Overを表示するテキスト
    public GameObject player;  // Scene上のPlayerゲームオブジェクト

    public Text text_Time;  // UIに経過時間を表示するテキスト 

    //【シーン間をまたいでデータを保持するStatic変数】
    public static float f_Time;  // ゲームの経過時間


    /////////////////////////////////
    // 【関数の設定】
    /////////////////////////////////

    //【ゲーム開始時に１回だけ動く関数】
    //（Unityの標準関数）
    void Start()
    {
        // ゲームスタート時に経過時間を初期化
        f_Time = 0;  
    }


    //【毎フレームに１度動く関数】
    //（Unityの標準関数）
    void Update()
    {
        // 経過時間をカウント
        f_Time += Time.deltaTime;
        // 画面上に経過時間を表示
        text_Time.text = f_Time.ToString("###.##");
    }


    //【ゲームオーバー時に他のプログラムから呼ばれるゲームオーバ処理の関数】
    public void GameOver()
    {
        // UIにGame Overのテキストを表示
        text_GameOver.SetActive(true);

        // Playerを消す
        player.SetActive(false);
    }


    //【リスタート用ボタンを押された際の処理関数】
    public void OnClickRestart()
    {
        // GameMainシーンを呼び出す
        SceneManager.LoadScene("GameMain");
    }


    //【他のシーンから本シーンの経過時間を取得する関数】
    public static float OnGet_Time()
    {
        // 本シーンの経過時間を返す
        return f_Time;
    }
}
